Index: branches/UKMO/dev_r4650_general_vert_coord_obsoper_surf_bgc/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_fco2.F90
===================================================================
--- branches/UKMO/dev_r4650_general_vert_coord_obsoper_surf_bgc/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_logchl.F90	(revision 6854)
+++ branches/UKMO/dev_r4650_general_vert_coord_obsoper_surf_bgc/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_fco2.F90	(revision 6856)
@@ -1,11 +1,11 @@
-MODULE obs_read_logchl
+MODULE obs_read_fco2
    !!======================================================================
-   !!                       ***  MODULE obs_read_logchl  ***
-   !! Observation diagnostics: Read the along track logchl data from
-   !!                          GHRSST or any logchl data from feedback files
+   !!                       ***  MODULE obs_read_fco2  ***
+   !! Observation diagnostics: Read the along track fco2 data from
+   !!                          GHRSST or any fco2 data from feedback files
    !!======================================================================
 
    !!----------------------------------------------------------------------
-   !!   obs_rea_logchl : Driver for reading logchl data from the feedback
+   !!   obs_rea_fco2 : Driver for reading fco2 data from the feedback
    !!----------------------------------------------------------------------
 
@@ -21,5 +21,5 @@
    USE obs_surf_def             ! Surface observation definitions
    USE obs_types                ! Observation type definitions
-   USE obs_logchl_io            ! I/O for logchl files
+   USE obs_fco2_io            ! I/O for fco2 files
    USE iom                      ! I/O
    USE netcdf                   ! NetCDF library
@@ -30,5 +30,5 @@
    PRIVATE
 
-   PUBLIC obs_rea_logchl      ! Read the logchl observations from the point data
+   PUBLIC obs_rea_fco2      ! Read the fco2 observations from the point data
    
    !!----------------------------------------------------------------------
@@ -40,13 +40,13 @@
 CONTAINS
 
-   SUBROUTINE obs_rea_logchl( kformat, &
-      &                    logchldata, knumfiles, cfilenames, &
+   SUBROUTINE obs_rea_fco2( kformat, &
+      &                    fco2data, knumfiles, cfilenames, &
       &                    kvars, kextr, kstp, ddobsini, ddobsend, &
       &                    ldignmis, ldmod )
       !!---------------------------------------------------------------------
       !!
-      !!                   *** ROUTINE obs_rea_logchl ***
-      !!
-      !! ** Purpose : Read from file the logchl data
+      !!                   *** ROUTINE obs_rea_fco2 ***
+      !!
+      !! ** Purpose : Read from file the fco2 data
       !!
       !! ** Method  : Depending on kformat either old or new style
@@ -66,9 +66,9 @@
       !                    ! 1: Old-style feedback
       TYPE(obs_surf), INTENT(INOUT) :: &
-         & logchldata     ! logchl data to be read
+         & fco2data     ! fco2 data to be read
       INTEGER, INTENT(IN) :: knumfiles   ! Number of corio format files to read in
       CHARACTER(LEN=128), INTENT(IN) :: cfilenames(knumfiles) ! File names to read in
-      INTEGER, INTENT(IN) :: kvars    ! Number of variables in logchldata
-      INTEGER, INTENT(IN) :: kextr    ! Number of extra fields for each var in logchldata
+      INTEGER, INTENT(IN) :: kvars    ! Number of variables in fco2data
+      INTEGER, INTENT(IN) :: kextr    ! Number of extra fields for each var in fco2data
       INTEGER, INTENT(IN) :: kstp     ! Ocean time-step index
       LOGICAL, INTENT(IN) :: ldignmis   ! Ignore missing files
@@ -78,5 +78,5 @@
          
       !! * Local declarations
-      CHARACTER(LEN=14), PARAMETER :: cpname='obs_rea_logchl'
+      CHARACTER(LEN=14), PARAMETER :: cpname='obs_rea_fco2'
       INTEGER :: ji
       INTEGER :: jj
@@ -95,6 +95,6 @@
          & irefdate
       INTEGER :: iobsmpp
-      INTEGER, PARAMETER :: ilogchlmaxtype = 1024
-      INTEGER, DIMENSION(0:ilogchlmaxtype) :: &
+      INTEGER, PARAMETER :: ifco2maxtype = 1024
+      INTEGER, DIMENSION(0:ifco2maxtype) :: &
          & ityp, &
          & itypmpp
@@ -105,5 +105,5 @@
          & iindx,    &
          & ifileidx, &
-         & ilogchlidx
+         & ifco2idx
       INTEGER :: itype
       REAL(wp), DIMENSION(:), ALLOCATABLE :: &
@@ -143,5 +143,5 @@
       ALLOCATE( inpfiles(inobf) )
 
-      logchl_files : DO jj = 1, inobf
+      fco2_files : DO jj = 1, inobf
           
          !---------------------------------------------------------------------
@@ -150,5 +150,5 @@
          IF(lwp) THEN
             WRITE(numout,*)
-            WRITE(numout,*) ' obs_rea_logchl : Reading from file = ', &
+            WRITE(numout,*) ' obs_rea_fco2 : Reading from file = ', &
                & TRIM( TRIM( cfilenames(jj) ) )
             WRITE(numout,*) ' ~~~~~~~~~~~~~~'
@@ -200,5 +200,5 @@
                ENDIF
             ELSEIF ( kformat == 1) THEN
-               CALL read_logchl( TRIM( cfilenames(jj) ), inpfiles(jj), &
+               CALL read_fco2( TRIM( cfilenames(jj) ), inpfiles(jj), &
                &                 numout, lwp, .TRUE. )
             ELSE
@@ -291,5 +291,5 @@
          ENDIF
 
-      END DO logchl_files
+      END DO fco2_files
 
       !-----------------------------------------------------------------------
@@ -311,5 +311,5 @@
 
       ALLOCATE( iindx(iobstot), ifileidx(iobstot), &
-         &      ilogchlidx(iobstot), zdat(iobstot) )
+         &      ifco2idx(iobstot), zdat(iobstot) )
       jk = 0
       DO jj = 1, inobf
@@ -319,5 +319,5 @@
                jk = jk + 1
                ifileidx(jk) = jj
-               ilogchlidx(jk) = ji
+               ifco2idx(jk) = ji
                zdat(jk)     = inpfiles(jj)%ptim(ji)
             ENDIF
@@ -328,8 +328,8 @@
          &               iindx   )
       
-      CALL obs_surf_alloc( logchldata, iobs, & 
+      CALL obs_surf_alloc( fco2data, iobs, & 
                            kvars, kextr, kstp, jpi, jpj )
       
-      ! * Read obs/positions, QC, all variable and assign to logchldata
+      ! * Read obs/positions, QC, all variable and assign to fco2data
  
       iobs = 0
@@ -343,5 +343,5 @@
          
          jj = ifileidx(iindx(jk))
-         ji = ilogchlidx(iindx(jk))
+         ji = ifco2idx(iindx(jk))
          IF ( ( inpfiles(jj)%ptim(ji) >  djulini(jj) ) .AND.  &
             & ( inpfiles(jj)%ptim(ji) <= djulend(jj) ) ) THEN
@@ -370,18 +370,18 @@
 
 
-               ! logchl time coordinates
-               logchldata%nyea(iobs) = iyea
-               logchldata%nmon(iobs) = imon
-               logchldata%nday(iobs) = iday
-               logchldata%nhou(iobs) = ihou
-               logchldata%nmin(iobs) = imin
+               ! fco2 time coordinates
+               fco2data%nyea(iobs) = iyea
+               fco2data%nmon(iobs) = imon
+               fco2data%nday(iobs) = iday
+               fco2data%nhou(iobs) = ihou
+               fco2data%nmin(iobs) = imin
                
-               ! logchl space coordinates
-               logchldata%rlam(iobs) = inpfiles(jj)%plam(ji)
-               logchldata%rphi(iobs) = inpfiles(jj)%pphi(ji)
+               ! fco2 space coordinates
+               fco2data%rlam(iobs) = inpfiles(jj)%plam(ji)
+               fco2data%rphi(iobs) = inpfiles(jj)%pphi(ji)
 
                ! Coordinate search parameters
-               logchldata%mi  (iobs) = inpfiles(jj)%iobsi(ji,1)
-               logchldata%mj  (iobs) = inpfiles(jj)%iobsj(ji,1)
+               fco2data%mi  (iobs) = inpfiles(jj)%iobsi(ji,1)
+               fco2data%mj  (iobs) = inpfiles(jj)%iobsj(ji,1)
                
                ! Instrument type
@@ -392,28 +392,28 @@
                   itype = 0
                ENDIF
-               logchldata%ntyp(iobs) = itype
-               IF ( itype < ilogchlmaxtype + 1 ) THEN
+               fco2data%ntyp(iobs) = itype
+               IF ( itype < ifco2maxtype + 1 ) THEN
                   ityp(itype+1) = ityp(itype+1) + 1
                ELSE
-                  IF(lwp)WRITE(numout,*)'WARNING:Increase ilogchlmaxtype in ',&
+                  IF(lwp)WRITE(numout,*)'WARNING:Increase ifco2maxtype in ',&
                      &                  cpname
                ENDIF
 
                ! Bookkeeping data to match observations
-               logchldata%nsidx(iobs) = iobs
-               logchldata%nsfil(iobs) = iindx(jk)
+               fco2data%nsidx(iobs) = iobs
+               fco2data%nsfil(iobs) = iindx(jk)
 
                ! QC flags
-               logchldata%nqc(iobs) = inpfiles(jj)%ivqc(ji,1)
+               fco2data%nqc(iobs) = inpfiles(jj)%ivqc(ji,1)
 
                ! Observed value
-               logchldata%robs(iobs,1) = inpfiles(jj)%pob(1,ji,1)
+               fco2data%robs(iobs,1) = inpfiles(jj)%pob(1,ji,1)
 
 
                ! Model and MDT is set to fbrmdi unless read from file
                IF ( ldmod ) THEN
-                  logchldata%rmod(iobs,1) = inpfiles(jj)%padd(1,ji,1,1)
+                  fco2data%rmod(iobs,1) = inpfiles(jj)%padd(1,ji,1,1)
                ELSE
-                  logchldata%rmod(iobs,1) = fbrmdi
+                  fco2data%rmod(iobs,1) = fbrmdi
                ENDIF
             ENDIF
@@ -434,5 +434,5 @@
 
          WRITE(numout,*)
-         WRITE(numout,'(1X,A)')'logchl data types'
+         WRITE(numout,'(1X,A)')'fco2 data types'
          WRITE(numout,'(1X,A)')'-----------------'
          DO jj = 1,8
@@ -450,5 +450,5 @@
       ! Deallocate temporary data
       !-----------------------------------------------------------------------
-      DEALLOCATE( ifileidx, ilogchlidx, zdat )
+      DEALLOCATE( ifileidx, ifco2idx, zdat )
 
       !-----------------------------------------------------------------------
@@ -460,6 +460,6 @@
       DEALLOCATE( inpfiles )
 
-   END SUBROUTINE obs_rea_logchl
-
-END MODULE obs_read_logchl
-
+   END SUBROUTINE obs_rea_fco2
+
+END MODULE obs_read_fco2
+